* macros_split_file_by_cat_var_string.SPS

* Initial file has string variable cat1 which has n different values .
* Objective is to create n (n is unknown) different files.
* The syntax works for any number of different values of cat1.

* Create a data file for illustration purposes.
DATA LIST FREE /cat1(A2).
BEGIN DATA
"A2" "B7" "01" "08" "W7" "XY"
"A2" "A2" "08" "W7" "W7" "XY"
"A2" "B7" "01" "08" "W7" "XY"
END DATA.

SAVE OUTFILE='c:\temp\mydata.sav'.

* Now start the job.

*///////////////.
DEFINE !split (filevar=!TOKENS(1) /value=!TOKENS(1))
TEMPORARY.
SELECT IF (!filevar=!value).
SAVE OUTFILE=!QUOTE(!CONCAT('c:\temp\f',!UNQUOTE(!value),'.sav.')).
!ENDDEFINE.
*///////////////.

*Find all different existing values of cat1.
SORT CASES BY cat1.
AGGREGATE OUTFILE=*
  /PRESORTED
  /BREAK=cat1  
  /notused = N.

* Write a syntax file to call the above macro.
WRITE OUTFILE='c:\temp\call macro.sps'
  /"!split filevar=cat1 value='" cat1 "'.".
EXECUTE.

* Get the original data file and do the macro calls.
GET FILE='c:\temp\mydata.sav'.
INCLUDE 'C:\temp\call macro.sps'.
